/*
 *   Copyright (C) 2007 Petri Damsten <damu@iki.fi>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef NEWS_HEADER
#define NEWS_HEADER

#include <Plasma/Applet>
#include <Plasma/DataEngine>
#include "ui_config.h"

namespace Plasma {
    class LineEdit;
    class Layout;
}

class News : public Plasma::Applet
{
    Q_OBJECT
    public:
        News(QObject *parent, const QVariantList &args);
        ~News();

        void paintInterface(QPainter *painter,
                const QStyleOptionGraphicsItem *option,
                const QRect& contentsRect);
        void setContentSize(const QSizeF& size);
        QSizeF contentSizeHint() const;

    public slots:
        void updated(const QString &name, const Plasma::DataEngine::Data &data);
        void showConfigurationInterface();

    protected Q_SLOTS:
        void dropEvent(QGraphicsSceneDragDropEvent *event);

    private slots:
        void configAccepted();
        void linkActivated(const QString &link);

    private:
        void connectToEngine();

    private:
        QSizeF m_size;
        QString m_feed;
        uint m_interval;
        Plasma::LineEdit *m_newsEdit;
        KDialog *m_dialog;
        Ui::config ui;
        QMap<QString, QString> m_defaultFeeds;
};

K_EXPORT_PLASMA_APPLET(news, News)

#endif
